unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Button3: TButton;
    CheckBox1: TCheckBox;
    ExitTimer: TTimer;
    TimerPeriodic: TTimer;
//    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExitTimerTimer(Sender: TObject);
    procedure TimerPeriodicTimer(Sender: TObject);
  private
    { Private declarations }
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure xGprinter;
    function FindPrinter(s:string):integer;
    function GetRestorePrinter: string;
    procedure periodic;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Printers, sbrs;

type Twhere = (dont, upperleft, lowerleft, upperright, lowerright);

var
originalPrinter:string;
where:Twhere;
Gexitnow:boolean;
Gprinter:string;
Gonce:boolean;
Gexternal:string;
Grestore:string;
Gidle:boolean;

const
Lf = #10;
Cr = #13;
LNEND = CR+LF;
crlf = CR+LF;
ESC = #27;

{.$define bug112216}


{$I tla.i}


{****************************************************************************
****************************************************************************}
{****************************************************************************


setdef `%s command-line error`%s.
Allowed (-/ supposed to work also):
-ul upper left (default)
-ll lower left
-ur upper right
-lr lower right
"-piX6800"
"-1mf4800"
"-xExternalPath"
"-rRestorePrinter"

****************************************************************************}


procedure getcmdline;
var
s:string;
i : integer;

const
opchar = '-'; otheropchar = '/';


  procedure explanations(why:string = '');
  begin

    if (length(why)>0) then
    why := safe_format(' ("%s")',[why]);

    infof(


'setdef %s command-line error%s.'
+LNEND+'Allowed (-/ supposed to work also):'
+LNEND+'-ul upper left (default)'
+LNEND+'-ll lower left'
+LNEND+'-ur upper right'
+LNEND+'-lr lower right'
+LNEND+'"-piX6800"'
+LNEND+'"-1mf4800"'
+LNEND+'"-xExternalPath"'
+LNEND+'"-rRestorePrinter"'

    ,
    [
    sTLA,
    why
    ] // leave a few extra.
    );
    Gexitnow := true;
  end;

begin

  for i := 1 to Paramcount do begin
    s  := copy(ParamStr(i),2,10000);  //get the argument to the option.

    if
    (ParamStr(i)[1]=opchar)
    or (ParamStr(i)[1]=otheropchar)
    then

    if      SameText(s,'ul') then
    where := UpperLeft
    else if sametext(s,'ll') then
    where := LowerLeft
    else if sametext(s,'ur') then
    where := UpperRight
    else if sametext(s,'lr') then
    where := LowerRight
    else if (s[1]='p')
    and (Gprinter='') then
    Gprinter := copy(s,2,1000)
    else if (s[1]='1') then begin
      Gprinter := copy(s,2,1000);
      Gonce := true;
    end else if (s[1]='x') then begin
      Gexternal := copy(s,2,1000);
    end else if (s[1]='r') then begin
      Grestore := copy(s,2,1000);
    end

    else begin
      explanations(ParamStr(i));
      exit;
    end
    else begin
      explanations(ParamStr(i));
      exit;
    end;
  end;
end;



{****************************************************************************
****************************************************************************}


function GetDefaultPrinter: string;
var
  ResStr: array[0..255] of Char;
begin
  GetProfileString('Windows', 'device', '', ResStr, 255);
  Result := StrPas(ResStr);
end;

procedure SetDefaultPrinter1(NewDefPrinter: string);
var
  ResStr: array[0..255] of Char;
begin
  if length(NewDefPrinter)<4 then
  exit;

  StrPCopy(ResStr, NewdefPrinter);
  WriteProfileString('windows', 'device', ResStr);
  StrCopy(ResStr, 'windows');
  SendMessage(HWND_BROADCAST, WM_WININICHANGE, 0, Longint(@ResStr));
end;

{$ifdef ACTUALLY_USED}
procedure SetDefaultPrinter2(PrinterName: string);
var
  I: Integer;
  Device: PChar;
  Driver: PChar;
  Port: PChar;
  HdeviceMode: THandle;
  aPrinter: TPrinter;
begin
  Printer.PrinterIndex := -1;
  GetMem(Device, 255);
  GetMem(Driver, 255);
  GetMem(Port, 255);
  aPrinter := TPrinter.Create;
  try
    for I := 0 to Printer.Printers.Count - 1 do
    begin
      if Printer.Printers[i] = PrinterName then
      begin
        aprinter.PrinterIndex := i;
        aPrinter.getprinter(device, driver, port, HdeviceMode);
        StrCat(Device, ',');
        StrCat(Device, Driver);
        StrCat(Device, Port);
        WriteProfileString('windows', 'device', Device);
        StrCopy(Device, 'windows');
        SendMessage(HWND_BROADCAST, WM_WININICHANGE,
          0, Longint(@Device));
      end;
    end;
  finally
    aPrinter.Free;
  end;
  FreeMem(Device, 255);
  FreeMem(Driver, 255);
  FreeMem(Port, 255);
end;
{$endif}

function Tform1.FindPrinter(s:string):integer;
var
i:integer;
label
GONE;
begin

  result := -1;

  if s<>'' then begin
    with Combobox1 do
    for i:=0 to items.count-1 do begin
      if pos(lowercase(s),lowercase(items[i]))>0 then begin
        result := i;
        goto GONE;
      end;
    end;


    GONE:
  end

end;

function TForm1.GetRestorePrinter: string;
var
i:integer;
begin
  result := '';
  if Grestore='' then
  exit;

  i := findPrinter(Grestore);

  if i>=0 then
  result := Combobox1.items[i];

end;


procedure Tform1.xGprinter;
var
i:integer;
label
GONE;
begin
  if Gprinter<>'' then begin
    i := findPrinter(Gprinter);
    if i>=0 then begin
      combobox1.ItemIndex := i;
      combobox1click(nil);  //actually sets the printer to specced default.
    end;

{****************************************************************************
  end else

Thu 11/24/2016 8:48 am. I'm pretty sure this is wrong. Shouldn't it do the
"-1" logic whether Gprinter or no? ... I hope so.....
****************************************************************************}
  end;

  if Gonce then begin
    Gonce := false;   //off the flag so we don't do it twice or something.
    exitTimer.Enabled := true; //set the once timer.
  end;
end;


{****************************************************************************
****************************************************************************}

procedure TForm1.FormCreate(Sender: TObject);
var
s:string;
begin
  autoscroll := true; //delphi mumbo jumbo font junk.

  getcmdline;

  if Gexitnow then begin
    exit;
  end;

  if Gidle then
  Application.onidle := AppIdle
  else
  TimerPeriodic.enabled := true;

  if Gexternal<>'' then begin
    DeleteFile(Gexternal); //off it to begin with.
  end;

  Combobox1.Items.Clear;
  Combobox1.Items.AddStrings(Printer.Printers);
//Fill the combobox with all available printers. Including weird non-existent
//ones.


//  Listbox1.Items.clear;
//  Listbox1.Items.AddStrings(Printer.Printers);

//  Button1Click(nil);

  combobox1.text := GetDefaultPrinter;
  //set-up with existing default printer.

  s := GetRestorePrinter;

  if (s<>'') then
  combobox1.Text := GetRestorePrinter;
  //set-up with specified to-restore default printer.


  //Then, *save* original or to-restore default printer.
  OriginalPrinter := combobox1.Text;
  button3.Caption := format('restore %s',[OriginalPrinter]);

  caption := safe_format('Set Default Printer %s',[sTLA]);

  case where of
    upperleft: begin
      left:=0 ;
      top:=0;
    end;

    lowerleft: begin
      left := 0;
      top := screen.Height - height;
    end;

    upperright: begin
      left:= screen.Width - width;
      top := 0;
    end;

    lowerright: begin
      left:= screen.Width - width;
      top := screen.Height - height;
    end;

//  else
//    left := 0; top := 0;
  end;

  if Gonce then begin
    CheckBox1.checked := false;
//    width := 10;
//    height := 10;
  end;

  //do something about command-line specified default printer.
  xGprinter;

end;


procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  SetDefaultPrinter1(Combobox1.Text);

end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  SetDefaultPrinter1(OriginalPrinter);
  combobox1.Text := OriginalPrinter;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If checkbox1.checked then begin
    SetDefaultPrinter1(OriginalPrinter);
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if (Gexitnow or Gonce) then begin
    close;
  end;
//  SetDefaultPrinter1(Combobox1.Text);
  onshow := nil;
//  comboBox1.style := csDropDownList; //makes it r/o? // makes it empty.

//  xGprinter;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

var
thekey:Word;
begin

  thekey := key;
  Key := 0;

  if thekey=ord(ESC) then
  close
//  unselectCombo;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  key := #0;
//  unselectCombo;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  key := 0;
//  unselectCombo;
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.periodic;
const
here : boolean = false;
label
GOAWAY;
begin
  if here then
  goto GOAWAY;

  here := true;

  if (Gexternal<>'')
  and FileExists(Gexternal) then begin
{$ifdef bug112216}
    button3.caption := safe_format('Hey there''s a %s!',[Gexternal]);
{$endif}

    DeleteFile(Gexternal);
    close;
  end;

//  unselectCombo;
  with combobox1 do begin


    if sellength <> 0 then
    sellength := 0;
  end;

//  CheckBox1.focus;
//  ActiveControl := CheckBox1; //that makes @F4 works AND @prtscrn.

  GOAWAY:
  here := false;

end;

//we have a choice to invoke the periodic task.

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
begin
  periodic;
end;


procedure TForm1.TimerPeriodicTimer(Sender: TObject);
begin
  periodic;
end;

{****************************************************************************
****************************************************************************}


procedure TForm1.ExitTimerTimer(Sender: TObject);
begin
  close;
end;


end.

